=== doc/kconfig_compiler/CMakeLists.txt ===
kde4_create_manpage(man-kconfig_compiler.1.docbook INSTALL_DESTINATION ${MAN_INSTALL_DIR})
