=== debian/changelog ===
kde4libs (4:4.4.5-2+squeeze4) squeeze-lts; urgency=low

  * Non-maintainer upload.
  * Fix CVE-2014-5033: insecure calling of polkit.

 -- Raphael Geissert <geissert@debian.org>  Mon, 20 Oct 2014 16:14:19 +0200

kde4libs (4:4.4.5-2+squeeze3) stable; urgency=low

  [ Ansgar Burchardt ]
  * Apply upstream patch to prevent marked text being cut out when switching
    documents in kate. (Closes: #636615)
    + new patch: 636615-ibus.diff

 -- Modestas Vainius <modax@debian.org>  Sun, 04 Sep 2011 09:28:50 +0300

kde4libs (4:4.4.5-2+squeeze2) stable; urgency=low

  [ José Manuel Santamaría Lema ]
  * Fix CVE-2011-1168 (Konqueror partially universal XSS in error pages) by
    cve_2011_1168_konqueror_xss.diff.
  * Fix CVE-2010-3170 (browser wildcard cerficate validation weakness) for
    Konqueror by cve_2010_3170_cn_wildcards.diff.
  * Fix CVE-2011-1094 (kdelibs does not properly verify that the server hostname
    matches the Common Name of the Subject of an X.509 certificate if that CN is
    an IP address) by cve_2011_1094_ssl_verify_hostname.diff.

  [ Modestas Vainius ]
  * KTar: use unsigned arithmetic when calculating checksum of tar header record
    (as per ustar specification). However, when reading archive, verify
    checksum by calculating it both ways (unsigned and signed) and accept if
    either matches (partially solves #612675). Implemented in
    ktar_header_checksum_fix.diff patch.
  * Fix KTar longlink support when filenames are encoded in the UTF-8 (or other
    multibyte) locale. Implemented in ktar_longlink_length_in_bytes.diff patch
    (thanks to Ibragimov Rinat). Closes: #612675

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Tue, 14 Jun 2011 00:13:57 +0300

kde4libs (4:4.4.5-2+squeeze1) stable-proposed-updates; urgency=low

  * Add a kconf_update script (migrate_from_kde3_icon_theme) to migrate away
    from old KDE 3 icon themes which are KDE 4 incompatible (e.g. crystalsvg).
    (Closes: #588374)

 -- Modestas Vainius <modax@debian.org>  Sat, 12 Feb 2011 21:14:55 +0200

kde4libs (4:4.4.5-2) unstable; urgency=low

  * Point debian/control Vcs fields to the new Git repository.
  * kdelibs5-data should break/replace kdelibs-data 4:3.5.10.dfsg.1-4 as well.
    That version still has the same files as kdelibs5-data.

 -- Modestas Vainius <modax@debian.org>  Fri, 26 Nov 2010 21:46:06 +0200

kde4libs (4:4.4.5-1) unstable; urgency=low

  [ Modestas Vainius ]
  * New upstream release.
  * Bump KPluginLoader and libplasma3 symbol versions to 4:4.4.4-2~.

  [ Sune Vuorela ]
  * mkstemps is now provided by libc, stop providing it in kdecore as
    well
  * Update email address.
  * Add vietnamese debconf translations. Thanks to Clytie Siddall.
    (Closes: 576144)

 -- Sune Vuorela <sune@debian.org>  Sat, 17 Jul 2010 22:41:52 +0200

kde4libs (4:4.4.4-2) unstable; urgency=high

  * Improve 10_make_libkdeinit4_private.diff patch:
    - fix kpluginloader.cpp:findLibraryInternal() to find moved libkdeinit4_*s.
      This should reenable kxkb flag in lock dialog (Closes: #584870);
    - set R(UN)PATH for kdeinit executables only when LIBKDEINIT_INSTALL_DIR is
      not in implicit link directory list;
    - extend absolute exe path resolution to libkdeinit4_*s in the kdeinit4
      daemon.
  * Replace 09_disable_usr_lib_install_rpath.diff with a less extreme version
    of the patch from kde4libs trunk which should keep support for
    custom prefix builds (Closes: #586512).
  * Relax KDE version check when loading plugins. This enables plugins compiled
    against newer kde4libs to work with older kde4libs at runtime as well
    (Closes: #585792). The patch covers KPluginLoader and plasmoids.
  * Urgency=high to get this into testing before 4.4.5 (see #585792).

 -- Modestas Vainius <modax@debian.org>  Wed, 23 Jun 2010 00:27:20 +0300

kde4libs (4:4.4.4-1) unstable; urgency=low

  * New upstream release.

  [ Modestas Vainius ]
  * Drop pkg-kde-tools from kdelibs5-dev Depends. Add it as versioned Breaks
    instead.
  * Bump pkg-kde-tools build dependency to (>= 0.9) for HTML_INSTALL_DIR
    switch and 3.0 (quilt) source format support.
  * Switch to 3.0 (quilt) source package format and original tar.bz2
    tarballs.
  * Add debian/NEWS about HTML_INSTALL_DIR switch and pkg-kde-tools drop from
    kdelibs5-dev Depends.
  * Replace usr/share/doc/kde4 references with usr/share/doc/kde.
  * Rename 28_find_kde3_html_documentation.diff to
    28_find_old_kde4_html_documentation.diff and modify it to look in the
    /usr/share/doc/kde4/HTML (old HTML_INSTALL_DIR default).
  * Drop quilt from Build-Depends, no longer needed for 3.0 (quilt).
  * Drop patch system stuff from debian/README.source. Patch support is part of
    source format now.
  * Drop 00_4.4.3_final_tarball.diff patch, it was stolen from upstream.
  * Add 30_kfileshare_kdesu_fileshareset.diff patch to run libexec/fileshareset
    with kdesu rather than expect it (perl script) to be suid root.

  [ Pino Toscano ]
  * Fix typo in description of kdelibs-bin. (Closes: #582433)

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Tue, 01 Jun 2010 01:15:11 +0300

kde4libs (4:4.4.3-2) unstable; urgency=medium

  [ Modestas Vainius ]
  * Confirm symbol files for 4.4.3 on all arches except alpha.
  * Restore kdelibs5-dev installability with libkwebkit-dev (>= 0.9svn1123738).
  * Bring our 4.4.3 up-to-date with final upstream 4.4.3 tarball
    (patch 00_4.4.3_final_tarball.diff).
  * Urgency=medium as this upload is needed to get kdenetwork with security
    fix in.

 -- Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>  Sun, 16 May 2010 22:30:03 +0300

kde4libs (4:4.4.3-1) unstable; urgency=low

  * New upstream release.

  [ Kai Wasserbäch ]
  * Update German Debconf translation. Thanks to Holger Wansing and Helge
    Kreutzmann. (Closes: #574015)

  [ Modestas Vainius ]
  * Update symbol files for 4.4.2 on hurd-i386 ia64 kfreebsd-amd64
    kfreebsd-i386 mips powerpc s390 sparc.

